/** @file dccp_recv.cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.4
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef DCCP_RECV_CMDLINE_H
#define DCCP_RECV_CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef DCCP_RECV_CMDLINE_PARSER_PACKAGE
/** @brief the program name (used for printing errors) */
#define DCCP_RECV_CMDLINE_PARSER_PACKAGE "dccp_recv"
#endif

#ifndef DCCP_RECV_CMDLINE_PARSER_PACKAGE_NAME
/** @brief the complete program name (used for help and version) */
#define DCCP_RECV_CMDLINE_PARSER_PACKAGE_NAME "dccp_recv"
#endif

#ifndef DCCP_RECV_CMDLINE_PARSER_VERSION
/** @brief the program version */
#define DCCP_RECV_CMDLINE_PARSER_VERSION "(paraslash 0.4.6, deterministic entropy)"
#endif

/** @brief Where the command line options are stored */
struct dccp_recv_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *detailed_help_help; /**< @brief Print help, including all details and hidden options, and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  char * host_arg;	/**< @brief ip or host (default='localhost').  */
  char * host_orig;	/**< @brief ip or host original value given at command line.  */
  const char *host_help; /**< @brief ip or host help description.  */
  int port_arg;	/**< @brief port to connect to (default='8000').  */
  char * port_orig;	/**< @brief port to connect to original value given at command line.  */
  const char *port_help; /**< @brief port to connect to help description.  */
  int* ccid_arg;	/**< @brief CCID preference(s) for this connection.  */
  char ** ccid_orig;	/**< @brief CCID preference(s) for this connection original value given at command line.  */
  unsigned int ccid_min; /**< @brief CCID preference(s) for this connection's minimum occurreces */
  unsigned int ccid_max; /**< @brief CCID preference(s) for this connection's maximum occurreces */
  const char *ccid_help; /**< @brief CCID preference(s) for this connection help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int detailed_help_given ;	/**< @brief Whether detailed-help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int host_given ;	/**< @brief Whether host was given.  */
  unsigned int port_given ;	/**< @brief Whether port was given.  */
  unsigned int ccid_given ;	/**< @brief Whether ccid was given.  */

} ;

/** @brief The additional parameters to pass to parser functions */
struct dccp_recv_cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure dccp_recv_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure dccp_recv_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *dccp_recv_args_info_purpose;
/** @brief the usage string of the program */
extern const char *dccp_recv_args_info_usage;
/** @brief all the lines making the help output */
extern const char *dccp_recv_args_info_help[];
/** @brief all the lines making the detailed help output (including hidden options and details) */
extern const char *dccp_recv_args_info_detailed_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int dccp_recv_cmdline_parser (int argc, char **argv,
  struct dccp_recv_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use dccp_recv_cmdline_parser_ext() instead
 */
int dccp_recv_cmdline_parser2 (int argc, char **argv,
  struct dccp_recv_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int dccp_recv_cmdline_parser_ext (int argc, char **argv,
  struct dccp_recv_args_info *args_info,
  struct dccp_recv_cmdline_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int dccp_recv_cmdline_parser_dump(FILE *outfile,
  struct dccp_recv_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int dccp_recv_cmdline_parser_file_save(const char *filename,
  struct dccp_recv_args_info *args_info);

/**
 * Print the help
 */
void dccp_recv_cmdline_parser_print_help(void);
/**
 * Print the detailed help (including hidden options and details)
 */
void dccp_recv_cmdline_parser_print_detailed_help(void);
/**
 * Print the version
 */
void dccp_recv_cmdline_parser_print_version(void);

/**
 * Initializes all the fields a dccp_recv_cmdline_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void dccp_recv_cmdline_parser_params_init(struct dccp_recv_cmdline_parser_params *params);

/**
 * Allocates dynamically a dccp_recv_cmdline_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized dccp_recv_cmdline_parser_params structure
 */
struct dccp_recv_cmdline_parser_params *dccp_recv_cmdline_parser_params_create(void);

/**
 * Initializes the passed dccp_recv_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void dccp_recv_cmdline_parser_init (struct dccp_recv_args_info *args_info);
/**
 * Deallocates the string fields of the dccp_recv_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void dccp_recv_cmdline_parser_free (struct dccp_recv_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int dccp_recv_cmdline_parser_required (struct dccp_recv_args_info *args_info,
  const char *prog_name);

extern const char *dccp_recv_cmdline_parser_ccid_values[];  /**< @brief Possible values for ccid. */


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* DCCP_RECV_CMDLINE_H */
